/*************************************************/
/*                  EloProxy                     */
/*************************************************/

#include <stdio.h>
#include <errno.h>
#include <sys/time.h>

#include <sys/param.h>
#include <sys/socket.h>
#include <sys/file.h>

#include <netinet/in_systm.h>
#include <netinet/in.h>
#include <netinet/ip.h>
#include <netinet/ip_icmp.h>
#include <netdb.h>
#include <signal.h>
#include <unistd.h>
#include <stdlib.h>
#include <time.h>
#include <sys/time.h>


#define MAXHOSTNAME 80

// Variables globales
int ByteUp = 0, ByteDown = 0, count=1;
float Tmed;
FILE *md;
int pid_matlab, pfd_matlab[2];
int status;

// Prototipos
void reusePort(int s);
int ProxyCom(int Clientsd, int Servesd);
int open_matlab(int *pfd_matlab, FILE* md);
int plot(float Tmed,int ByteUp, int ByteDown, int *count, FILE* md);
static void sig_alrm(int signo);
static void sig_cerrar(int signo);

int main( int argc, char *argv[] )
{
	int s_ClientArrive;
	struct sockaddr_in server;
	struct sockaddr_in fromClient;
	int fromClientlen;
	int length;
	fd_set readfds, readfdsCopy;
	int n,i;
 	int sockListClient[64], lastSockC=0;

	int server_fromlen;
	struct sockaddr_in addr;
	struct sockaddr_in server_from;
	struct sockaddr_in real_server;
	struct servent *sp;
	struct hostent *hp;
	int sockListServe[64], lastSockS = 0;

	int puerto_listen, puerto_destino, rc, Dt, Bytes;
	char host_destino[MAXHOSTNAME], ThisHost[MAXHOSTNAME], buf[100000];
	char * pEnd;

	// Recibimiento de argumentos del comando
	if (argc == 5){
		puerto_listen = atoi(argv[1]);
		strcpy(host_destino, argv[2]);
		puerto_destino = atoi(argv[3]);
		if ((Tmed = atof(argv[4])) <= 0)
			exit(-1);
	}

	else {
		printf("USO: eloproxy <puerto_listen> <host_destino> <puerto_destino> <delta_t_en_segundos>\n");
		exit(0);
	}


	/**************************/
	/*  Datos Servidor Proxy  */
	/**************************/

	server.sin_family = AF_INET;
	server.sin_addr.s_addr = htonl(INADDR_ANY);
	server.sin_port = htons(puerto_listen);

	s_ClientArrive = socket (AF_INET,SOCK_STREAM,0);
	reusePort(s_ClientArrive);

	if ( bind( s_ClientArrive, (struct sockaddr *)&server, sizeof(server) ) ) {
		close(s_ClientArrive);
		perror("binding name to stream socket");
		exit(-1);
	}

	length = sizeof(server);
	if ( getsockname (s_ClientArrive, (struct sockaddr *)&server,&length) ) {
		perror("getting socket name");
		exit(0);
	}

	printf("    Puerto conexion cliente: %d\n", ntohs(server.sin_port));


	/****************************/
	/*  Datos Servidor Destino  */
	/****************************/

	sp = getservbyname("echo", "tcp");

	gethostname(ThisHost, MAXHOSTNAME);

	printf("----EloProxy corriendo en: %s\n", ThisHost);
	if  ( (hp = gethostbyname(ThisHost)) == NULL ) {
		fprintf(stderr, "Can't find host %s\n", ThisHost);
		exit(-1);
	}
	bcopy ( hp->h_addr, &(real_server.sin_addr), hp->h_length);
	printf("    (IP: %s )\n", inet_ntoa(real_server.sin_addr));

	if  ( (hp = gethostbyname(host_destino)) == NULL ) {
		addr.sin_addr.s_addr = inet_addr(host_destino);
		if ((hp = gethostbyaddr((void *)&addr.sin_addr.s_addr,
				sizeof(addr.sin_addr.s_addr),AF_INET)) == NULL) {
			fprintf(stderr, "Can't find host %s\n", host_destino);
			exit(-1);
		}
	}
	printf("----Servidor corriendo en: %s\n", hp->h_name);
	bcopy ( hp->h_addr, &(real_server.sin_addr), hp->h_length);
	printf("    (IP: %s )\n", inet_ntoa(real_server.sin_addr));

	real_server.sin_family = hp->h_addrtype;

	real_server.sin_port = htons(puerto_destino);

	/*****************************/
	/*  Inicialización de matlab */
	/*****************************/
	// inicializa el arreglo de descriptores destinado a la comunicacion con "Matlab"   
	if (pipe(pfd_matlab) < 0) {
		perror("pipe");
		exit(1);
	}

	// Llamado a Fork duplica el programa creando un proceso hijo (Matlab).
	// Esta funcion retorna un 0 al hijo y el pid del hijo al padre
	if ((pid_matlab = fork()) < 0) {
		perror("fork");
		exit(1);
	}


	// El proceso hijo cierra la pipa de lectura y se convierte en el
	// comando ping mediante exclp(). El hijo NO continua con este codigo.   
	if (pid_matlab == 0) {
		dup2(pfd_matlab[0], 0);
		close(pfd_matlab[1]);
		close(1);
		execlp("matlab", "matlab", (char *) 0);
		perror("exec");
		exit(-1);
	}

	close(pfd_matlab[0]);

	md = fdopen(pfd_matlab[1],"w");


	if ( signal(SIGALRM, sig_alrm) == SIG_ERR )
		printf("error de temporizador");
	alarm(Tmed);

	if ( signal(SIGINT, sig_cerrar) == SIG_ERR )
		printf("error de termino");

	listen(s_ClientArrive,4);
	fromClientlen = sizeof(fromClient);
	FD_ZERO(&readfdsCopy);
	FD_SET(s_ClientArrive,&readfdsCopy);


	/*************************/
	/*  Cuerpo del Programa  */
	/*************************/
	for(;;){

		memcpy(&readfds, &readfdsCopy, sizeof(fd_set));      // Actualización del arreglo de sockets activos
		n = select(FD_SETSIZE, &readfds, NULL, NULL, NULL);  // Atiende si hay requeriemintos en los socket creados

		if (n > 0) {

			if (FD_ISSET(s_ClientArrive, &readfds)) {
				// zona de código para realizaar una nueva conección (Cliente-Proxy-Servidor)
				// Si el socket que "escucha" (s_ClientArrive) es escrito
				// significa que un nuevo cliente ha llegado

				printf("Aceptando conexion...\n");
				sockListClient[lastSockC++] = accept(s_ClientArrive, (struct sockaddr *)&fromClient, &fromClientlen);
				FD_SET(sockListClient[lastSockC-1], &readfdsCopy);

				// Se crea el socket para conectar el Proxy con cliente que ha llegado
				sockListServe[lastSockS++] = socket (hp->h_addrtype,SOCK_STREAM,0);
				FD_SET(sockListServe[lastSockS-1], &readfdsCopy);

				if (sockListServe[lastSockS-1] < 0) {
					perror("opening stream socket");
					exit(-1);
				}

				// Se conecta hacia el otro extremo, el Proxy al servidor requerido
				if ( connect(sockListServe[lastSockS-1], (struct sockaddr *)&real_server, sizeof(real_server)) < 0 ) {
					close(sockListServe[lastSockS-1]);
					perror("connecting stream socket");
					exit(0);
				}
				server_fromlen = sizeof(server_from);
				if (getpeername(sockListServe[lastSockS-1], (struct sockaddr *)&server_from,&server_fromlen)<0){
					perror("could't get peername\n");
					exit(1);
				}
				printf("\n----Conectado al sevidor TCP:");
				printf("%s:%d\n", inet_ntoa(server_from.sin_addr),
						ntohs(server_from.sin_port));
				if ((hp = gethostbyaddr((void *)&server_from.sin_addr.s_addr,
						sizeof(server_from.sin_addr.s_addr),AF_INET)) == NULL)
					fprintf(stderr, "Can't find host %s\n", inet_ntoa(server_from.sin_addr));
				else
				printf("    (Nombre : %s)\n", hp->h_name);
			}

			// Revisión de los sockets abiertos para clientes.
			// se revisa cual fue el socket "en movimiento" y
			// se realiza la operación correspondiente.
			for (i=0; i < lastSockC; i++) {
				if (FD_ISSET(sockListClient[i], &readfds)) {
					if ((Bytes = ProxyCom(sockListClient[i], sockListServe[i])) < 0) {
						// Si no hay datos transferidos se asume término de conexión
						// y la comunicación es cerrada.
						FD_CLR(sockListClient[i], &readfdsCopy);
						close (sockListClient[i]);
						sockListClient[i] = sockListClient[--lastSockC];

						FD_CLR(sockListServe[i], &readfdsCopy);
						close (sockListServe[i]);
						sockListServe[i] = sockListServe[--lastSockS];

						i--;
						printf("Number of current clients: %d\n", lastSockC);

					}
				// Acumulación de bytes transferidos en la subida
				ByteUp = ByteUp + Bytes;
				}
			}

			// Revisión de los sockets abiertos para servidor
			// se revisa cual fue el socket "en movimiento" y
			// se realiza la operación correspondiente.
			for (i=0; i < lastSockS; i++) {
				if (FD_ISSET(sockListServe[i], &readfds)) {
					if (( Bytes = ProxyCom(sockListServe[i], sockListClient[i])) < 0) {
						// Si no hay datos transferidos se asume término de conexión
						// y la comunicación es cerrada.
						FD_CLR(sockListClient[i], &readfdsCopy);
						close (sockListClient[i]);
						sockListClient[i] = sockListClient[--lastSockC];

						FD_CLR(sockListServe[i], &readfdsCopy);
						close (sockListServe[i]);
						sockListServe[i] = sockListServe[--lastSockS];

						i--;
					}
				// Acumulación de bytes transferidos en la bajada
				ByteDown = ByteDown + Bytes;
				}
			}


		}

	}

	return 0;

}


/**************************************************************************************/
/*  ProxiCom realiza la comunicación entre cliente y servidor leyendo los datos que   */
/*  son enviados y reescribiendolos en el otro socket. En esta operación son medidos  */
/*  los datos transferidos                                                            */
/**************************************************************************************/

int ProxyCom(int Clientsd, int Servesd)
{
	char buf[1000000];
	int rc;             // variable que almacena los bytes transferidos
	int i=0;

	for(;;) {

		if( (rc=read(Clientsd, buf, sizeof(buf))) < 0)
			perror("receiving stream  message");

		if (rc > 0) {
			buf[rc]='\0';

			if (send(Servesd, buf, rc, 0) <0 )
				perror("sending stream message");

			return(rc);
		}

		else {
			printf("Disconnected..\n");
			return(-1);
		}

  	}

}

/*************************************************************/
/* Rutina para setear la reutilización del puerto utilizado  */
/* al finalizar su utilización                               */
/*************************************************************/
void reusePort(int s)
{
	int one=1;

	if ( setsockopt(s,SOL_SOCKET,SO_REUSEADDR,(char *) &one,sizeof(one)) == -1 ) {
		printf("error in setsockopt,SO_REUSEPORT \n");
		exit(-1);
	}

}

/**********************************************************************/
/*  sig_alarm es llamada cada Tmed [s] (definidos por el usuario) y   */
/* realizaa el cálculo y ploteo de la tasa ded transmisión            */
/**********************************************************************/
static void sig_alrm(int signo){

	// Grafica los primeros 10 puntos
	if ( 10 > count) {
		// Creacion de vector "U" (subida) y "D" (bajada) de Tasa de bytes transferidos
		fprintf(md,"U(%d) = ", count);
		fprintf(md,"%f;\n", (ByteDown/Tmed));
		fprintf(md,"D(%d) = ", count);
		fprintf(md,"%f;\n", (ByteDown/Tmed));
		fflush(md);
	
		// Creacion de vector de numeros de tiempo tiempo en Matlab
		fprintf(md,"tiempo(%d) = %f;\n", count, Tmed*count);
		fflush(md);
		fprintf(md,"subplot(2,1,1)\n");
		fflush(md);
		fprintf(md,"plot(tiempo(1:%d),U(1:%d),'o-');\n",count, count);
		fflush(md);

		fprintf(md,"subplot(2,1,2)\n");
		fflush(md);
		fprintf(md,"plot(tiempo(1:%d),D(1:%d),'o-');\n", count, count); 
		fflush(md);

		// Escritura de ejes y titulos de graficos
		fprintf(md,"subplot(2,1,1);\n");
  		fflush(md);
     		fprintf(md,"title('Tasa de Subida');\n");
     		fflush(md);
		fprintf(md,"xlabel('Tiempo [s]');\n");
  		fflush(md);
  		fprintf(md,"ylabel('Tasa de transferencia [Bytes/s]');\n");
		fflush(md);
   
		fprintf(md,"subplot(2,1,2);\n");
		fflush(md);
		fprintf(md,"title('Tasa de Bajada');\n");
		fflush(md);
		fprintf(md,"xlabel('Tiempo [s]');\n");
		fflush(md);
		fprintf(md,"ylabel('Tasa de transferencia [Bytes/s]');\n");
		fflush(md);
	}
	
	// Adapta la ventana de gráfico a solo 10 puntos
	else {
	
		fprintf(md,"U(%d) = ", count);
		fprintf(md,"%f;\n", (ByteUp/Tmed));
		fprintf(md,"D(%d) = ", count);
		fprintf(md,"%f;\n", (ByteDown/Tmed));
		fflush(md);

		// Creacion de vector de numeros de tiempo tiempo en Matlab
		fprintf(md,"tiempo(%d) = %f;\n", count, Tmed*count);
		fflush(md);
		fprintf(md,"subplot(2,1,1)\n");
		fflush(md);
		fprintf(md,"plot(tiempo((%d-10):%d),U((%d-10):%d),'o-');\n",count, count,count, count);
		fflush(md);

		fprintf(md,"subplot(2,1,2)\n");
		fflush(md);
		fprintf(md,"plot(tiempo((%d-10):%d),D(%d-10:%d),'o-');\n", count, count, count, count); 
		fflush(md);

		// Escritura de ejes y titulos de graficos
		fprintf(md,"subplot(2,1,1);\n");
  		fflush(md);
     		fprintf(md,"title('Tasa de Subida');\n");
     		fflush(md);
		fprintf(md,"xlabel('Tiempo [s]');\n");
  		fflush(md);
  		fprintf(md,"ylabel('Tasa de transferencia [Bytes/s]');\n");
		fflush(md);
	   
		fprintf(md,"subplot(2,1,2);\n");
		fflush(md);
		fprintf(md,"title('Tasa de Bajada');\n");
		fflush(md);
		fprintf(md,"xlabel('Tiempo [s]');\n");
		fflush(md);
		fprintf(md,"ylabel('Tasa de transferencia [Bytes/s]');\n");
		fflush(md);
	}

	ByteUp = 0;
	ByteDown = 0;
	count++;	
   
	// Se reinicializa el contador de alarma para generación de próxima interrupción
	alarm(Tmed);
	return;        
	
}

/*******************************************/
/*  Función de finalización de programa.   */
/*  Cierre EloProxy y Matlab               */
/*******************************************/
static void sig_cerrar(int signo){
	
	if (signo != SIGINT ) {
		printf("Senal no valida");
		return;
	}
	
	fflush(md);
	fclose(md);
	kill(pid_matlab, SIGINT);
	waitpid(pid_matlab, &status, 0);
	exit(0);

}




